#!/usr/bin/python
import glob
import coloredlogs
import logging
import matplotlib.pyplot as plt
import pickle
import labellines
import re
import argparse
import numpy as np

coloredlogs.install(level=logging.INFO)

parser = argparse.ArgumentParser(description='Plot multiple power budget for different orbits')
parser.add_argument('plot_file', nargs='*', help='.plot.pickle files to show, generated by the power_budget.py script', default=glob.glob("./*.plot.pickle"))
parser.add_argument('--consumption', '-c', help='Power consumption file', required=True)

args = parser.parse_args()
files = args.plot_file

logging.info("Found {} files to plot".format(len(files)))

with open(args.consumption, "rb") as file:
    data = pickle.load(file)

    #data = (data[0][::3], data[1][::10])

    plt.plot(data[0], data[1], color='black', label='Power Consumption (+ eff. + 10%)', linestyle='-', linewidth=3, zorder=100)
    plt.fill_between(data[0], data[1], 2.5, alpha=0.1, color='#A30015')

files.sort()

for path in files:
    # if not "450" in path:
        # continue

    with open(path, "rb") as file:
        logging.info("Plotting {}".format(path))

        data = pickle.load(file)

        match = re.search(r'([^\/]+?)(\..*$|$)', path)
        label = match[1]

        plt.plot(data[0], data[1], label=label)

plt.tight_layout()
plt.xlabel('Date', fontsize=22.5)
plt.ylabel('Orbit Average Power (W)', fontsize=22.5)
plt.ylim([2.5, None])
plt.grid()

# Sort labels by mean
handles, labels = plt.gca().get_legend_handles_labels()
labels, handles = zip(*sorted(zip(labels, handles), key=lambda t: -np.mean(t[1].get_ydata())))

plt.legend(handles, labels, fontsize=20, loc="best", fancybox=True, framealpha=0.8)
plt.tick_params(labelsize=17)
# for line in plt.gca().get_lines():
    # line.set_rasterized(True)
plt.show()

